summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author William PC2022-10-01 00:39:50 +0200
committer Willy Sudiarto Raharjo2022-10-01 04:01:16 +0200
commitb007d9bbe9c91466ad22e0ca81ff05858f3236dd (patch)
tree7859538a5d8c2e8433fa95f49f39fe3c4906b308
parentd1301168987ead4227c523b9dd837ff581f09120 (diff)
downloadslackbuilds-b007d9bbe9c91466ad22e0ca81ff05858f3236dd.tar.gz
libraries/scalapack: Added (Scalable Linear Algebra PACKage)
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--libraries/scalapack/README6
-rw-r--r--libraries/scalapack/scalapack.SlackBuild121
-rw-r--r--libraries/scalapack/scalapack.info10
-rw-r--r--libraries/scalapack/slack-desc19
4 files changed, 156 insertions, 0 deletions
diff --git a/libraries/scalapack/README b/libraries/scalapack/README
new file mode 100644
index 0000000000..c8bb34669a
--- /dev/null
+++ b/libraries/scalapack/README
@@ -0,0 +1,6 @@
+ ScaLAPACK is a library of high-performance linear algebra routines
+for parallel distributed memory machines. ScaLAPACK solves dense and
+banded linear systems, least squares problems, eigenvalue problems,
+and singular value problems.
+
+* NOTE: version 2.2.0 Fortran linking problem at xzls
diff --git a/libraries/scalapack/scalapack.SlackBuild b/libraries/scalapack/scalapack.SlackBuild
new file mode 100644
index 0000000000..cb56acb631
--- /dev/null
+++ b/libraries/scalapack/scalapack.SlackBuild
@@ -0,0 +1,121 @@
+#!/bin/bash
+
+# Slackware build script for ScaLAPACK
+
+# Copyright 2022 William PC - Seattle, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=scalapack
+VERSION=${VERSION:-2.1.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tgz
+cd $PRGNAM-$VERSION
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# Fortran compiling get's error, to avoid it set flags "-std=legacy"
+
+# building without cmake, it works but doesn't compile shared libs
+#cp -av SLmake.inc.example SLmake.inc
+#sed -i 's/NOOPT*.*= -O0/& -std=legacy/' SLmake.inc
+#sed -i 's/FCFLAGS*.*= -O3/& -std=legacy/' SLmake.inc
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DCMAKE_BUILD_TYPE=Release \
+ -DBUILD_SHARED_LIBS=ON \
+ -DBUILD_SHARED_LIBS=OFF \
+ -DCMAKE_Fortran_FLAGS="-std=legacy" \
+ ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+# Don't ship .la files:
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG -depth -type d -empty -delete || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a LICENSE README $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/scalapack/scalapack.info b/libraries/scalapack/scalapack.info
new file mode 100644
index 0000000000..45ce743716
--- /dev/null
+++ b/libraries/scalapack/scalapack.info
@@ -0,0 +1,10 @@
+PRGNAM="scalapack"
+VERSION="2.1.0"
+HOMEPAGE="https://netlib.org/scalapack"
+DOWNLOAD="http://www.netlib.org/scalapack/scalapack-2.1.0.tgz"
+MD5SUM="3b239ef80353c67354a0a62d54946fa8"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="blas lapack openmpi"
+MAINTAINER="William PC"
+EMAIL="w_calandrini[at]hotmail[dot]com"
diff --git a/libraries/scalapack/slack-desc b/libraries/scalapack/slack-desc
new file mode 100644
index 0000000000..98836b1fd8
--- /dev/null
+++ b/libraries/scalapack/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+scalapack: scalapack (Scalable Linear Algebra PACKage)
+scalapack:
+scalapack:
+scalapack: ScaLAPACK is a library of high-performance linear algebra routines
+scalapack: for parallel distributed memory machines. ScaLAPACK solves dense and
+scalapack: banded linear systems, least squares problems, eigenvalue problems,
+scalapack: and singular value problems.
+scalapack:
+scalapack:
+scalapack:
+scalapack: